<template>
  <div id="project">
    <CoscineHeadline :headline="$t('page.configMetadata.headline')" />
    <b-row>
      <div class="col-sm-2" />
      <div class="col-sm-8">
        <b-form id="edit_form" @submit.stop.prevent="clickSave">
          <FormNaming
            v-model="projectForUpdate"
            :disabled="!isOwner"
            :is-loading="isLoading"
            @validation="setNamingValidation"
          /><!-- TODO: Fix @validation assignment and typing -->

          <FormReadonlyData
            v-model="projectForUpdate"
            :disabled="!isOwner"
            :is-loading="isLoading"
          />

          <FormMetadata
            v-model="projectForUpdate"
            :disabled="!isOwner"
            :is-loading="isLoading"
            :current-project="project"
            :parent-project="parentProject"
            @validation="setMetadataValidation"
          /><!-- TODO: Fix @validation assignment and typing -->

          <b-form-group v-if="isOwner" class="mb-3">
            <!-- Submit Button -->
            <b-button
              id="SubmitProjectBtn"
              type="submit"
              variant="primary"
              class="float-end"
              :disabled="
                formValidations.naming.$invalid ||
                formValidations.metadata.$invalid ||
                (!formValidations.naming.$anyDirty &&
                  !formValidations.metadata.$anyDirty) ||
                isWaitingForResponse
              "
              @click.prevent="clickSave"
            >
              {{ $t("buttons.submit") }}
            </b-button>

            <!-- Delete Button -->
            <b-button
              id="DeleteProjectBtn"
              variant="danger"
              class="float-start"
              @click.prevent="isDeleteModalVisible = true"
            >
              {{ $t("buttons.delete") }}
            </b-button>
          </b-form-group>
        </b-form>

        <!-- Delete Project Modal -->
        <DeleteProjectModal
          v-if="project"
          :open="isDeleteModalVisible"
          :display-name="project.displayName ?? undefined"
          @close="isDeleteModalVisible = false"
          @clickDelete="clickDelete"
        />

        <LoadingSpinner :is-waiting-for-response="isWaitingForResponse" />
      </div>
      <div class="col-sm-2" />
    </b-row>
  </div>
</template>

<script lang="ts">
import FormNaming from "./components/FormNaming.vue";
import FormReadonlyData from "./components/FormReadonlyData.vue";
import FormMetadata from "./components/FormMetadata.vue";
import DeleteProjectModal from "./components/modals/DeleteProjectModal.vue";

// import the store for current module
import useProjectStore from "../store";
import useNotificationStore from "@/store/notification";
import { navigateToProject } from "@/router";

import type { BaseValidation } from "@vuelidate/core";
import type {
  ProjectDto,
  ProjectForCreationDto,
  ProjectForUpdateDto,
  VisibilityForProjectManipulationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import {
  ProjectDto2ProjectForUpdateDto,
  projectMapper,
} from "@/mapping/project";

export default defineComponent({
  components: {
    FormNaming,
    FormReadonlyData,
    FormMetadata,
    DeleteProjectModal,
  },
  setup() {
    const projectStore = useProjectStore();
    const notificationStore = useNotificationStore();

    return { projectStore, notificationStore };
  },

  data() {
    return {
      projectForUpdate: {
        description: "",
        displayName: "",
        startDate: "",
        endDate: "",
        pid: "",
        keywords: [] as string[],
        name: "",
        principleInvestigators: "",
        grantId: "",
        slug: "",
        disciplines: [],
        organizations: [],
        visibility: {} as VisibilityForProjectManipulationDto,
      } as ProjectForUpdateDto,

      formValidations: {
        naming: {} as BaseValidation<ProjectDto>,
        metadata: {} as BaseValidation<ProjectDto>,
      },

      isLoading: false,
      isWaitingForResponse: false,
      isDeleteModalVisible: false,
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    parentProject(): ProjectDto | null {
      if (
        this.projectStore.currentParentProjects &&
        this.projectStore.currentParentProjects.length > 0
      ) {
        // --- set b-placeholder while filling parent-project form ---
        return this.projectStore.currentParentProjects[0];
      } else {
        return null;
      }
    },
    isOwner(): boolean | undefined {
      return this.projectStore.currentUserRoleIsOwner;
    },
  },

  watch: {
    project() {
      // Filling the form requires a watcher for the cases
      // when project may be unset (e.g. when entering from a direct link)
      this.onProjectLoaded();
    },
  },

  async created() {
    this.isLoading = true;
    await this.fetchData();
    // Fill the project form
    this.onProjectLoaded();
    this.isLoading = false;
  },

  methods: {
    async fetchData() {
      // Load Project Visibilities if not present
      if (this.projectStore.visibilities === null) {
        await this.projectStore.retrieveVisibilities();
      }
      // Load Project Disciplines if not present
      if (this.projectStore.disciplines === null) {
        await this.projectStore.retrieveDisciplines();
      }
    },
    onProjectLoaded() {
      if (this.project) {
        this.isLoading = true;
        // Fill the form. Note that regular assignment breaks reactivity!
        const mapped = projectMapper.map(
          ProjectDto2ProjectForUpdateDto,
          this.project,
        );
        Object.assign(this.projectForUpdate, mapped); // Use this to only copy the properties
        this.isLoading = false;
      }
    },

    async clickDelete() {
      this.isDeleteModalVisible = false;
      if (this.project) {
        const success = await this.projectStore.deleteProject(this.project);
        if (success) {
          // Always the 0-th element
          const parentProject = this.projectStore.currentParentProjects
            ? this.projectStore.currentParentProjects[0]
            : null;
          // Refresh the project information in the store
          await this.projectStore.refreshProjectInformation(parentProject);
          // Replace the current location with parent project or project list
          this.notificationStore.postNotification({
            title: this.$t("toast.onDelete.success.title").toString(),
            body: this.$t("toast.onDelete.success.message").toString(),
          });
          navigateToProject(parentProject);
        } else {
          // On Failure
          this.notificationStore.postNotification({
            title: this.$t("toast.onDelete.failure.title").toString(),
            body: this.$t("toast.onDelete.failure.message").toString(),
            variant: "danger",
          });
        }
      }
    },

    async clickSave() {
      // Validate form again
      this.formValidations.naming.$touch();
      this.formValidations.metadata.$touch();
      // Check if there are errors in each form and if they were changed
      if (
        !(this.project && this.project.id) ||
        this.formValidations.naming.$invalid ||
        this.formValidations.metadata.$invalid ||
        (!this.formValidations.naming.$anyDirty &&
          !this.formValidations.metadata.$anyDirty)
      ) {
        console.error("The form is invalid!");
        return;
      }

      this.isWaitingForResponse = true;

      const success = await this.projectStore.updateProject(
        this.project.id,
        this.projectForUpdate,
      );

      this.isWaitingForResponse = false;
      if (success) {
        // On Success
        this.formValidations.naming.$reset();
        this.formValidations.metadata.$reset();
        // Refresh the project information in the store
        await this.projectStore.refreshProjectInformation(this.project);
        this.notificationStore.postNotification({
          title: this.$t("toast.onSave.success.title").toString(),
          body: this.$t("toast.onSave.success.message").toString(),
        });
      } else {
        // On Failure
        this.notificationStore.postNotification({
          title: this.$t("toast.onSave.failure.title").toString(),
          body: this.$t("toast.onSave.failure.message").toString(),
          variant: "danger",
        });
      }
    },

    setNamingValidation(
      validation: BaseValidation<ProjectForCreationDto | ProjectForUpdateDto>,
    ) {
      // Use any to resolve a weird TypeScript error between Validations
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      this.formValidations.naming = validation as any;
    },
    setMetadataValidation(
      validation: BaseValidation<ProjectForCreationDto | ProjectForUpdateDto>,
    ) {
      // Use any to resolve a weird TypeScript error between Validations
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      this.formValidations.metadata = validation as any;
    },
  },
});
</script>
